*** Note ***

*** Do NOT Compile this prg
*** This prg is just to set you up for trying samples in this Demo Project
*** After running this, you should be able to run all stuff inside project. 
*** To verify succesfull dev setup - run helloworld test script

***See readme.txt for run time deployment instructions

clear all  &&Remove this line if it bugs up your stuff and call this prg
&&from your own development setup routine


********************RS / GDI+X  Inititalision sequence **********
local cRootFolder,cGdiPlusX
cRootFolder = justpath(justpath(sys(16,1)) )  
do addbs(cRootFolder) + 'ReportSculptor.App'

** Initialise GdiPlusX supplied in subfolder of this project 
** (Required version 1.20 with EMF support!)
cGdiPlusX=Addbs(_oRSGO.RS_Root) + 'GdiPlusX\system_lean.app'
do (cGdiPlusX)
*******************************************************************


set default to (cRootFolder)
set procedure to sys(16,1) additive
set path to ;data;FreeTables;forms;GRAPHICS;LIBS;PROGS;REPORTS

*** Important !!!

*** As indicated in Redme.txt, for compiling purposes
*** Code below (two functions and RS Engine subclass) has to be appended to some run time
*** visible code library.( Along with other general purpose functions you use)

*** If you have done that already, and below functions & class are 'visible' at all times
*** then you should remove them from this prg to avoid having the same code in two different
*** places (as this situation might cause confusion).
*** Code below is used by this demo project when you are going through samples


************************************
function rsGlobalObjectSetup
    with _oRSGO

        **Global properties applied at RS Engine instantiation
        .xfrx_active = 'N'  &&Change to 'Y' if you are using XFRX
        .xfrx_path   = '\XFRX'   &&Set your own XFRX run time path


        .rs_EngineClass = 'MyRS'    && RS Engine Subclass used to customise RS Engine
        &&(Just below this function)
      
        .LanguagesEnabled=.f.   && To use or create localisation set to .t. 
        .myLanguage = 'English' && Set to your own language (if translation exist) 
                                && See Localise_Strings.prg for creating new language table/translation 
     
      

    endwith





***Supporting Function for .LoadFrx() method 
function RsFrx
    lparameters cFrxFile,cForClause,cWhileClause,cScope,cSummary
    if Type('cFrxFile') <> 'C'
        return .f.
    endif
    if vartype(cForClause) <> 'C' or len(alltrim(cForClause)) = 0
        cForClause  = '.t.'
    endif
    if vartype(cWhileClause) <> 'C'  or len(alltrim(cWhileClause)) = 0
        cWhileClause = '.t.'
    endif

    local loReportListener,oRptStream
    oRptStream =  createobject('Frx2RsConverter')
    loReportListener = createobject("RsFrxReader")
    loReportListener.oRSRead  = oRptStream

    report form (cFrxFile)  for &cForClause while &cWhileClause object loReportListener

    loReportListener.release
    loReportListener=null

    return oRptStream


    ********************************************************************
    * Customise RS Engine Calss via this subclass  
    * Attach your own pageheader/footer, call your own preview form etc.
    ********************************************************************
define class MyRS as rsEngine

    lAutoPageHeader=.t.
    lAutoPageFooter=.t.
    rsPublicsHeader='Report Sculptor Version 0.95 Beta'  && Set your own default header/footer strings here
    rsPublicsFooter='Report Sculptor Version 0.95 Beta'  && Then retry HelloWorld example to verify customisation
                                                         && More Customisation tips will folow later

    *** And don't forget that this subclass and above ini function have to be appended to some run time
    *** visible code library.( Along with other general purpose functions you use)

    
    **To Run your own custom form , remove comment from this line 
    
    * rsPreviewScx = '.\Forms\myRsPreview.scx'



    procedure WithFile  && Invoked from .OutPut() method after file created
        lparameters cFile
        ****Customize to distribute file,
        ****Copy,rename,Edit,Show in browser or watever else you might want to do


    procedure EmailOutput && Invoked from RS Preview Form / Button Export pressed
        lparameters cFile
         
       
        ***Simple emailing using Outlook
        ***Customize to implement your own emailing

        #define oleEmailItem 0
        local oOutlook,oEmail
        oOutlook = createobject('Outlook.Application')
        oEmail = oOutlook.CreateItem(oleEmailItem)

        oEmail.to = 'admin@report-sculptor.com'
        oEmail.CC = ''
        oEmail.subject='Report Sculptor - Sample'
        oEmail.body='I Love Report Sculptor :) '
        oEmail.Attachments.add(cFile)
        oEmail.display



enddefine


